(in-package :iolib.examples)

(defun run-ex1-client (&key (port *port*))

  (setf iolib.sockets:*ipv6* nil)

  ;; Create a internet TCP socket under IPV4
  (let ((socket
         (iolib.sockets:make-socket 
          :connect :active
          :address-family :internet
          :type :stream 
          :external-format '(:utf-8 :eol-style :crlf)
          :ipv6 nil)))

       ;; do a blocking connect to the daytime server on the port.
       (sockets:connect socket (lookup-hostname "localhost") :port port :wait t)

       (format t "Connected to server ~A:~A via my local connection at ~A:~A!~%"
               (sockets:remote-name socket) (sockets:remote-port socket)
               (sockets:local-name socket) (sockets:local-port socket))

       ;; read the one line of information I need form the daytime server.
       ;; I can use read-line here because this is a TCP socket.
       (let ((line (read-line socket)))
            (format t "~A" line))

       (close socket)
       t))
