(in-package :iolib.examples)

(defun run-ex3-client-helper (port)

  ;; Create a internet TCP socket under IPV4
  (with-open-socket
   (socket :connect :active
           :address-family :internet
           :type :stream 
           :external-format '(:utf-8 :eol-style :crlf)
           :ipv6 nil)

   ;; do a blocking connect to the daytime server on the port.
   (connect socket (lookup-hostname "black") :port port :wait t)

   (format t "Connected to server ~A:~A from my local connection at ~A:~A!~%"
           (remote-name socket) (remote-port socket)
           (local-name socket) (local-port socket))

   ;; read the one line of information I need form the daytime server.
   ;; I can use read-line here because this is a TCP socket. It will block
   ;; until the whole line is read.
   (let ((line (read-line socket)))
        (format t "~A" line)
        t)))

(defun run-ex3-client (&key (port *port*))
  (handler-case

   (run-ex3-client-helper port)

   (socket-connection-refused-error
    ()
    (format t "Connection refused to ~A:~A. Maybe the server isn't running?~%"
            (lookup-hostname "localhost") port))

   (end-of-file
    ()
    (format t "The server closed the connection before we could read the time~%"))))


